routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/


Route::group(['middleware'=>'language'],function () {
    Route::get('/home', 'HomeController@index')->name('home');
    Auth::routes();
    Route::get('/', "PhotosController@index");
    Route::get('photos.profiles/{user}', "PhotosController@profiles")->where('id','+id')->name('photos.profiles');
    Route::resource('photos','PhotosController');
    Route::resource('photos.comments', 'PhotoCommentsController')->only('store');

});

Route::get('language/{locale}', 'LanguageSwitcherController@switcher')
    ->name('language.switcher')
    ->where('locale', 'en|ru');

app/Photo.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Orchid\Attachment\Attachable;
use Orchid\Filters\Filterable;
use Orchid\Screen\AsSource;

class Photo extends Model
{
    use AsSource, Attachable, Filterable;
    protected $fillable = ['title', 'user_id', 'image'];

    /**
     * @return \Illuminate\Database\Eloquent\Relations\BelongsTo
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }

    /**
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function comments()
    {
        return $this->hasMany(Comment::class);
    }
}

app/Http/Controllers/PhotosController.php
<?php

namespace App\Http\Controllers;

use App\Comment;
use App\Http\Requests\PhotoRequest;
use App\Photo;
use App\User;
use Illuminate\Http\Request;

class PhotosController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth')->except('index','profiles',);
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function index()
    {
        return view('photos.index', ['photos' => Photo::all()]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('photos.create');
    }


    /**
     * @param PhotoRequest $request
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function store(PhotoRequest $request)
    {
        $photo = new Photo();
        $photo->title = $request->input('title');
        $photo->user_id = $request->user()->id;
        $file = $request->file('image');
        if (!is_null($file)){
            $path = $file->store('image', 'public');
            $photo['image'] = $path;
        }
        $photo->save();
        return redirect(route('photos.index'));
    }

    /**
     * @param Photo $photo
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show(Photo $photo)
    {
        return view('photos.show',['photo' => $photo]);
    }


    /**
     * @param Photo $photo
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit(Photo $photo)
    {
        return view('photos.edit',['photo' => $photo]);
    }


    /**
     * @param PhotoRequest $request
     * @param Photo $photo
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     */
    public function update(PhotoRequest $request, Photo $photo)
    {
        $photo->update($request->all());
        return redirect(route('photos.index'));
    }


    /**
     * @param Photo $photo
     * @return \Illuminate\Http\RedirectResponse|\Illuminate\Routing\Redirector
     * @throws \Exception
     */
    public function destroy(Photo $photo)
    {
        $photo->delete();
        return redirect(route('photos.index'));
    }

    /**
     * @param User $user
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function profiles(User $user)
    {
        $comment = Comment::latest()->first();
        $photo = Photo::latest()->first();
        $collections= collect(['users' => User::all()]);
        return view('photos.profiles', [
            'collections' => $collections,
            'user' =>$user,
        ]);


    }


}

app/View/Components/Photo.php
<?php


namespace App\View\Components;


use Illuminate\View\Component;

class Photo extends Component
{
    public $photo;

    /**
     * Create a new component instance.
     *
     * @param $photo
     */
    public function __construct($photo)
    {
        $this->photo = $photo;
    }

    /**
     * Get the view / contents that represent the component.
     *
     * @return \Illuminate\View\View|string
     */
    public function render()
    {
        return view('component.photo', $this->photo);
    }
}

resources/views/photos/create.blade.php
@extends('layouts.app')
@section('content')
    <h1>Create new Photo</h1>
    <form  enctype="multipart/form-data" method="post" action="{{route('photos.store')}}">
        @csrf
        <div class="custom-file">
            <label class="custom-label" for="validatedInputGroupCustomFile">Title</label>
            <input name="title" type="text">
        </div>
        <div class="input-group is-invalid">

            <div class="custom-file">
                <input  name="image" type="file" class="custom-file-input" id="validatedInputGroupCustomFile" required>
                <label class="custom-file-label" for="validatedInputGroupCustomFile">Upload photo...</label>
            </div>
            <div class="input-group-append">
                <button class="btn btn-outline-secondary" type="submit">Download</button>
            </div>
        </div>
    </form>
@endsection

resources/views/photos/edit.blade.php
@extends('layouts.app')
@section('content')
    <h1>Edit Photo</h1>
    <form  enctype="multipart/form-data" method="post" action="{{route('photos.update', $photo)}}">
        @method('put')
        @csrf
        <div class="custom-file">
            <label class="custom-label" for="validatedInputGroupCustomFile">Title</label>
            <input name="title" value="{{$photo->title}}" type="text">
        </div>
        <div class="input-group is-invalid">

            <div class="custom-file">
                <input  name="image" type="file" class="custom-file-input" id="validatedInputGroupCustomFile" value="{{$photo->image}}" required>
                <label class="custom-file-label" for="validatedInputGroupCustomFile">Upload photo...</label>
            </div>
            <div class="input-group-append">
                <button class="btn btn-outline-secondary" type="submit">Download</button>
            </div>
        </div>
    </form>
@endsection

resources/views/photos/index.blade.php
@extends('layouts.app')
@section('content')
    <div class="container">
        <div class="row">
            @foreach($photos as $photo)

                <div class="modal fade" id="staticBackdrop-{{$photo->id}}" data-backdrop="static" data-keyboard="false" tabindex="-1" role="dialog" aria-labelledby="staticBackdropLabel" aria-hidden="true">
                    <div class="modal-dialog">
                        <div class="modal-content">
                            <div class="modal-header">

                                {{--                                @cannot(Auth::user())--}}

                                <a href="{{route('photos.profiles',['user' => $photo->user])}}">
                                    @csrf
                                    <h5 class="modal-title" id="staticBackdropLabel">{{$photo->user->name}}</h5>
{{--                                    @csrf--}}
                                </a>
{{--                                @endcannot--}}
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">

                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <h4> {{$photo->title}}</h4>
                            <div class="modal-body">
                                <span class="likebtn-wrapper" data-theme="large" data-lang="ru" data-identifier="{{$photo->user->id}}"></span>
                                <div id="comments-block" class="col-8 scrollit comments-block">
                                    @foreach($photo->comments as $comment)
                                        <x-comment :comment="$comment"></x-comment>
                                    @endforeach
                                </div>
                                <div class="col-4">
                                    <div class="comment-form">
                                        <form id="create-comment-{{$photo->id}}" class="create-comment">
                                            @csrf
                                            @method('post')
                                            <input type="hidden" id="photo_id-{{$photo->id}}" value="{{$photo->id}}">
                                            <div class="form-group">
                                                <label for="body">Комментарий</label>
                                                <textarea name="body" class="form-control" id="body" rows="3" required></textarea>
                                            </div>
                                            <p><select id="estimation" name="estimation">
                                                    <option selected disabled>Выберите оценку</option>
                                                    <option value="1">1</option>
                                                    <option value="2">2</option>
                                                    <option value="3">3</option>
                                                    <option value="4">4</option>
                                                    <option value="5">5</option>
                                                </select></p>
                                            <button  id="create-comment-btn" data-photo-id="{{$photo->id}}" type="submit" class="btn btn-outline-primary btn-sm btn-block create-comment-btn">Добавьте новый
                                                комментарий
                                            </button>
                                        </form>
                                    </div>
                                </div>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>
                @csrf
                <div style="margin: auto;padding-top: 20px" class="col-xl-4 col-md-4 col-lg-4">
                    <div  style="border-radius: 300px; height: 300px; width: 300px"  class="thumb">
                        <button type="button" style="border-radius: 300px; height: 300px; width: 300px;" data-toggle="modal" data-target="#staticBackdrop-{{$photo->id}}">
                            <img src="{{asset('storage/'.$photo->image)}}" class="card-img" style="border-radius: 300px; height: 300px; width: 300px; margin-left: -6px; margin-top: -2px"  alt="{{$photo->id}}">
                        </button>
                    </div>
                </div>

            @endforeach
        </div>
    </div>
@endsection

resources/views/photos/profiles.blade.php
@extends('layouts.app')
@section('content')
    <h1>{{$user->name}}</h1>
    @if(Auth::user()->id == $user->id)
    <h3>My photos<a href="{{route('photos.create')}}">Create new photo</a></h3>
    @endif
    <div class="container">
        <table class="table">
            <thead>
            <tr>
                <th scope="col">Photo</th>
                <th scope="col">Title</th>
                <th scope="col">Action</th>
            </tr>
            </thead>
            <tbody>
@foreach($user->photos as $photo)
        <tr>
            <td>
                <img src="{{asset('storage/'.$photo->image)}}" class="card-img" style="border-radius: 300px; height: 300px; width: 300px; margin-left: -6px; margin-top: -2px"  alt="{{$photo->id}}">
            </td>
            <td>
                {{$photo->title}}
            </td>
            <td>
                @if(Auth::user()->id == $user->id)
               <a href="{{route('photos.edit', ['photo' => $photo])}}">Edit</a>
                @endif
                <br>
                <a href="{{route('photos.show', ['photo' => $photo])}}"> Remove</a>
                <br>
                    @if(Auth::user()->id == $user->id)
                <form method="post" action="{{route('photos.destroy',['photo' => $photo])}}">
                    @method('delete')
                    @csrf
                    <button type="submit">delete</button>
                </form>
                        @endif
            </td>
        </tr>
            </tbody>
            @endforeach
        </table>
    </div>

@endsection

resources/views/photos/show.blade.php
@extends('layouts.app')
@section('content')
    <h2>{{($photo->title)}}</h2>
        <img src="{{asset('storage/'.$photo->image)}}" class="card-img" style=" margin-left: -6px; margin-top: -2px"  alt="{{$photo->id}}">
    <div class="modal-body">
        <span class="likebtn-wrapper" data-theme="large" data-lang="ru" data-identifier="{{$photo->user->id}}"></span>
        <div class="row">
            <div id="comments-block" class="col-8 scrollit">
                @foreach($photo->comments as $comment)
                    <x-comment :comment="$comment"></x-comment>
                @endforeach
            <div class="col-4">
                <div class="comment-form">
                    <form id="create-comment-{{$photo->id}}">
                        @csrf
                        <input type="hidden" id="photo_id-{{$photo->id}}" value="{{$photo->id}}">
                        <div class="form-group">
                            <label for="body">Комментарий</label>
                            <textarea name="body" class="form-control" id="body" rows="3" required></textarea>
                        </div>
                        <p><select id="estimation" name="estimation">
                                <option selected disabled>Выберите оценку</option>
                                <option value="1">1</option>
                                <option value="2">2</option>
                                <option value="3">3</option>
                                <option value="4">4</option>
                                <option value="5">5</option>
                            </select></p>
                        <button  id="create-comment-btn" data-photo-id="{{$photo->id}}" type="submit" class="btn btn-outline-primary btn-sm btn-block create-comment-btn">Добавьте новый
                            комментарий
                        </button>
                    </form>
                </div>
            </div>
        </div>
        </div>
    </div>
@endsection